import {connect} from 'react-redux';
import ChronicInfo from '../components/ChronicInfo';
import {SHOW_TABLE_LIST,HIDE_TABLE_LIST} from '@store/types/pushMessage';
import {getTableList,getScaleInfo,getTips} from '../store/async-actions/pushMessage';
import {ADD_ASSESS_ITEMS,SET_SAVE_ASSESS_DATA} from "@types/assessResult";
import {saveMessage} from "../store/async-actions/print";
import {saveClickNum} from '@store/async-actions/homePage';

function mapStateToProps(state){
  return{
    chronicMagItem: state.diagnosticList.chronicMagItem,
    questionId: state.diagnosticList.clickDiag,
    tableList: state.pushMessage.tableList,
    showList: state.pushMessage.showList,
    scaleInfo: state.pushMessage.scaleInfo,//量表内容
    chronicDesease:state.mainSuit.chronicDesease,//主诉存的慢病
    update:state.assessResult.update1,
    formulaResult:state.pushMessage.formulaResult //量表信息
  }
}

function mapDispatchToProps(dispatch){
  return {
    getTableList(id){
      dispatch(getTableList(id))
      dispatch({type:SHOW_TABLE_LIST})
    },
    hideList(){
      dispatch({type:HIDE_TABLE_LIST})
    },
    getScaleInfo(item){
      dispatch(getScaleInfo(item))
    },
    addAssessItem(row,pIndex,i){         //加入评估记录
      let obj = Object.assign({},row);
      //obj.details[i].add=true;
      dispatch({
        type:ADD_ASSESS_ITEMS,
        data:obj,
        index:pIndex,
        subIndex:i
      })
    },
    //保存管理评估
    saveAssessInfos(obj){
      dispatch(Object.assign({},obj,{type:SET_SAVE_ASSESS_DATA}));
      dispatch(saveClickNum);
      dispatch(() => saveMessage())
    },
    // 获取量表静态知识
    getInfomation(item){
      dispatch(getTips(item));
    }
  }
}

const ChronicInfoContainer = connect(mapStateToProps,mapDispatchToProps)(ChronicInfo);
export default ChronicInfoContainer;